Package org.apache.groovy.ginq.dsl.expression

# Class AbstractGinqExpression

java.lang.Object
org.codehaus.groovy.ast.ASTNode
org.codehaus.groovy.ast.AnnotatedNode
org.codehaus.groovy.ast.expr.Expression
org.apache.groovy.ginq.dsl.expression.AbstractGinqExpression

All Implemented Interfaces:
  `GroovydocHolder<AnnotatedNode>`, `NodeMetaDataHandler`

Direct Known Subclasses:
  `DataSourceExpression`, `GinqExpression`, `ProcessExpression`, `SetOperationExpression`, `ShutdownExpression`

public abstract class AbstractGinqExpression extends Expression implements NodeMetaDataHandler
Represents GINQ expression which could hold metadata

Since:
  4.0.0

- ## Field Summary

  ### Fields inherited from class org.codehaus.groovy.ast.expr.Expression

  `EMPTY_ARRAY`

  ### Fields inherited from interface groovy.lang.groovydoc.GroovydocHolder

  `DOC_COMMENT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractGinqExpression()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract <R> R`
  `accept(GinqAstVisitor<R> visitor)`
  Accepts a GINQ visitor.
  `Expression`
  `transformExpression(ExpressionTransformer transformer)`
  Returns this expression because GINQ expressions are transformed elsewhere.
  `void`
  `visit(GroovyCodeVisitor visitor)`
  Does nothing because GINQ expressions are visited through `GinqAstVisitor`.

  ### Methods inherited from class org.codehaus.groovy.ast.expr.Expression

  `getType, setType, transformExpressions, transformExpressions`

  ### Methods inherited from class org.codehaus.groovy.ast.AnnotatedNode

  `addAnnotation, addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, getGroovydoc, getInstance, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`

  ### Methods inherited from class org.codehaus.groovy.ast.ASTNode

  `copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getMetaDataMap, getText, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setMetaDataMap, setSourcePosition`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.NodeMetaDataHandler

  `copyNodeMetaData, getMetaDataMap, getNodeMetaData, getNodeMetaData, getNodeMetaData, newMetaDataMap, putNodeMetaData, removeNodeMetaData, setMetaDataMap, setNodeMetaData`

- ## Constructor Details

  - ### AbstractGinqExpression

    public AbstractGinqExpression()

- ## Method Details

  - ### transformExpression

    public Expression transformExpression(ExpressionTransformer transformer)
    Returns this expression because GINQ expressions are transformed elsewhere.
    Specified by:
      `transformExpression` in class `Expression`
    Parameters:
      `transformer` - the transformer requesting the change
    Returns:
      this expression

  - ### accept

    public abstract <R> R accept(GinqAstVisitor<R> visitor)
    Accepts a GINQ visitor.
    Type Parameters:
      `R` - the visit result type
    Parameters:
      `visitor` - the visitor to accept
    Returns:
      the visit result

  - ### visit

    public void visit(GroovyCodeVisitor visitor)
    Does nothing because GINQ expressions are visited through `GinqAstVisitor`.
    Overrides:
      `visit` in class `ASTNode`
    Parameters:
      `visitor` - the Groovy code visitor